Index: /LMDZ4/trunk/libf/phylmd/buffer_mod.F90
===================================================================
--- /LMDZ4/trunk/libf/phylmd/buffer_mod.F90	(revision 1001)
+++ /LMDZ4/trunk/libf/phylmd/buffer_mod.F90	(revision 1001)
@@ -0,0 +1,86 @@
+MODULE buffer_mod
+
+PRIVATE
+  REAL,PARAMETER :: grow_factor=1.5
+
+  INTEGER, POINTER, SAVE :: buffer_i(:)
+  INTEGER,SAVE :: size_buffer_i = 0
+!$OMP THREADPRIVATE(buffer_i,size_buffer_i)
+
+  REAL,POINTER,SAVE      :: buffer_r(:)
+  INTEGER,SAVE :: size_buffer_r = 0 
+!$OMP THREADPRIVATE(buffer_r,size_buffer_r)
+  
+  LOGICAL,POINTER,SAVE   :: buffer_l(:)
+  INTEGER,SAVE :: size_buffer_l = 0
+!$OMP THREADPRIVATE(buffer_l,size_buffer_l)
+
+  CHARACTER,POINTER,SAVE :: buffer_c(:)
+  INTEGER,SAVE :: size_buffer_c = 0
+!$OMP THREADPRIVATE(buffer_c,size_buffer_c)
+
+INTERFACE get_buffer
+  MODULE PROCEDURE get_buffer_i, get_buffer_r, get_buffer_l, get_buffer_c
+END INTERFACE
+  
+PUBLIC :: get_buffer
+
+CONTAINS
+
+  SUBROUTINE get_buffer_i(buff,buff_size)
+  IMPLICIT NONE
+    INTEGER,POINTER    :: buff(:)
+    INTEGER,INTENT(IN) :: buff_size 
+
+    IF (buff_size>size_buffer_i) THEN
+      DEALLOCATE(buffer_i)
+      size_buffer_i=MAX(2,INT(size_buffer_i*grow_factor))
+      ALLOCATE(buffer_i(size_buffer_i))
+    ENDIF
+    
+    buff=>buffer_i
+  END SUBROUTINE get_buffer_i
+
+  SUBROUTINE get_buffer_r(buff,buff_size)
+  IMPLICIT NONE
+    REAL,POINTER       :: buff(:)
+    INTEGER,INTENT(IN) :: buff_size 
+
+    IF (buff_size>size_buffer_r) THEN
+      DEALLOCATE(buffer_r)
+      size_buffer_r=MAX(2,INT(size_buffer_r*grow_factor))
+      ALLOCATE(buffer_r(size_buffer_r))
+    ENDIF
+    
+    buff=>buffer_r
+  END SUBROUTINE get_buffer_r
+
+  SUBROUTINE get_buffer_l(buff,buff_size)
+  IMPLICIT NONE
+    LOGICAL,POINTER    :: buff(:)
+    INTEGER,INTENT(IN) :: buff_size 
+
+    IF (buff_size>size_buffer_l) THEN
+      DEALLOCATE(buffer_l)
+      size_buffer_l=MAX(2,INT(size_buffer_l*grow_factor))
+      ALLOCATE(buffer_l(size_buffer_l))
+    ENDIF
+    
+    buff=>buffer_l
+  END SUBROUTINE get_buffer_l
+  
+  SUBROUTINE get_buffer_c(buff,buff_size)
+  IMPLICIT NONE
+    CHARACTER,POINTER  :: buff(:)
+    INTEGER,INTENT(IN) :: buff_size 
+
+    IF (buff_size>size_buffer_c) THEN
+      DEALLOCATE(buffer_c)
+      size_buffer_c=MAX(2,INT(size_buffer_c*grow_factor))
+      ALLOCATE(buffer_c(size_buffer_c))
+    ENDIF
+    
+    buff=>buffer_c
+  END SUBROUTINE get_buffer_c
+  
+END MODULE buffer_mod
Index: /LMDZ4/trunk/libf/phylmd/clesphys.h
===================================================================
--- /LMDZ4/trunk/libf/phylmd/clesphys.h	(revision 1000)
+++ /LMDZ4/trunk/libf/phylmd/clesphys.h	(revision 1001)
@@ -48,4 +48,6 @@
        INTEGER :: ip_ebil_phy, iflag_rrtm
        LOGICAL ok_slab_sicOBS
+       LOGICAL :: ok_strato
+       LOGICAL :: ok_hines
 
        COMMON/clesphys/cycle_diurne, soil_model, new_oliq,              &
@@ -62,5 +64,5 @@
      &     , freq_ISCCP, ecrit_ISCCP, ip_ebil_phy                       &
      &     , ok_slab_sicOBS, ok_lic_melt, cvl_corr                      &
-     &     , qsol0, iflag_rrtm
+     &     , qsol0, iflag_rrtm, ok_strato,ok_hines
      
 !$OMP THREADPRIVATE(/clesphys/)
Index: /LMDZ4/trunk/libf/phylmd/conf_phys.F90
===================================================================
--- /LMDZ4/trunk/libf/phylmd/conf_phys.F90	(revision 1000)
+++ /LMDZ4/trunk/libf/phylmd/conf_phys.F90	(revision 1001)
@@ -1,2 +1,3 @@
+
 !
 ! $Header$
@@ -120,11 +121,12 @@
   LOGICAL,SAVE :: ok_lic_melt_omp
 !
-!
-    LOGICAL,SAVE :: cycle_diurne_omp,soil_model_omp,new_oliq_omp
-    LOGICAL,SAVE :: ok_orodr_omp, ok_orolf_omp, ok_limitvrai_omp
-    INTEGER, SAVE :: nbapp_rad_omp, iflag_con_omp
-!
-
-!$OMP MASTER
+  LOGICAL,SAVE :: cycle_diurne_omp,soil_model_omp,new_oliq_omp
+  LOGICAL,SAVE :: ok_orodr_omp, ok_orolf_omp, ok_limitvrai_omp
+  INTEGER, SAVE :: nbapp_rad_omp, iflag_con_omp
+  LOGICAL,SAVE :: ok_strato_omp
+  LOGICAL,SAVE :: ok_hines_omp
+!
+
+!$OMP MASTER 
 !Config Key  = OCEAN 
 !Config Desc = Type d'ocean
@@ -1094,4 +1096,20 @@
   call getin('alphas',alphas_omp)
 
+!Config key = ok_strato
+!Config  Desc = activation de la version strato
+!Config  Def  = .FALSE.
+!Config  Help = active la version stratosphérique de LMDZ de F. Lott
+
+  ok_strato_omp=.FALSE.
+  CALL getin('ok_strato',ok_strato_omp)
+      
+!Config  key = ok_hines
+!Config  Desc = activation de la parametrisation de hines
+!Config  Def  = .FALSE.
+!Config  Help = Clefs controlant la parametrization de Hines
+!               Et la sponge layer (Runs Stratospheriques)
+
+  ok_hines_omp=.FALSE.
+  CALL getin('ok_hines',ok_hines_omp)
 
 
@@ -1210,6 +1228,7 @@
     Fmax = Fmax_omp
     alphas = alphas_omp
-
-!$OMP MASTER
+    ok_strato = ok_strato_omp
+    ok_hines = ok_hines_omp
+    
 
 ! Attribution of new parmeters according to parameters in .def
@@ -1230,4 +1249,6 @@
        CALL abort_gcm('conf_phys','ocean not valid',1)
     END IF
+
+!$OMP MASTER
 
   write(numout,*)' ##############################################'
@@ -1327,4 +1348,7 @@
  & ecrit_hf, ecrit_day, ecrit_mth, ecrit_reg, ecrit_tra, ecrit_ISCCP
 
+  write(numout,*) 'ok_strato = ', ok_strato
+  write(numout,*) 'ok_hines = ',  ok_hines
+  
 !$OMP END MASTER
 
Index: /LMDZ4/trunk/libf/phylmd/cpl_mod.F90
===================================================================
--- /LMDZ4/trunk/libf/phylmd/cpl_mod.F90	(revision 1000)
+++ /LMDZ4/trunk/libf/phylmd/cpl_mod.F90	(revision 1001)
@@ -85,9 +85,9 @@
   !$OMP THREADPRIVATE(cpl_windsp2D)
   
-! variables for OPENMP parallelisation
+! variable for OPENMP parallelisation
+
   INTEGER,ALLOCATABLE,DIMENSION(:),SAVE :: knon_omp
   REAL,ALLOCATABLE,DIMENSION(:,:),SAVE ::  buffer_omp
   
-
 CONTAINS
 !
@@ -255,6 +255,6 @@
 
 !$OMP MASTER
-    ALLOCATE(knon_omp(0:omp_size-1)) 
-    ALLOCATE(buffer_omp(klon_mpi,0:omp_size-1))       
+  ALLOCATE(knon_omp(0:omp_size-1)) 
+  ALLOCATE(buffer_omp(klon_mpi,0:omp_size-1))       
 !$OMP END MASTER
 !$OMP BARRIER
@@ -311,6 +311,7 @@
        time_sec=(itime-1)*dtime
 #ifdef CPP_COUPLE
+    il_time_secs=(itime-1)*dtime
 !$OMP MASTER
-       CALL fromcpl(time_sec, tab_read_flds)
+    CALL fromcpl(il_time_secs, tab_read_flds)
 !$OMP END MASTER
 #endif
@@ -324,4 +325,5 @@
           END DO
        ENDIF
+
 
 ! Save each field in a 2D array. 
@@ -945,5 +947,5 @@
     REAL, DIMENSION(klon_mpi)                            :: rlon_mpi, rlat_mpi
 
-#ifdef CPP_PARA
+#ifdef CPP_MPI
     INCLUDE 'mpif.h'
     INTEGER, DIMENSION(MPI_STATUS_SIZE)                  :: status
@@ -1001,20 +1003,20 @@
     IF (is_omp_root) THEN
 
-       DO j = 1, jj_nb
-          tmp_calv(:,j) = DOT_PRODUCT (cpl_rlic2D(1:iim,j), &
-               pctsrf2D(1:iim,j,is_lic)) / REAL(iim)
-       ENDDO
-       
-    
-       IF (is_parallel) THEN
+      DO j = 1, jj_nb
+         tmp_calv(:,j) = DOT_PRODUCT (cpl_rlic2D(1:iim,j), &
+              pctsrf2D(1:iim,j,is_lic)) / REAL(iim)
+      ENDDO
+    
+    
+      IF (is_parallel) THEN
          IF (.NOT. is_north_pole) THEN
-#ifdef CPP_PARA
+#ifdef CPP_MPI
             CALL MPI_RECV(Up,1,MPI_REAL_LMDZ,mpi_rank-1,1234,COMM_LMDZ_PHY,status,error)
             CALL MPI_SEND(tmp_calv(1,1),1,MPI_REAL_LMDZ,mpi_rank-1,1234,COMM_LMDZ_PHY,error)
 #endif
          ENDIF
-          
+       
          IF (.NOT. is_south_pole) THEN
-#ifdef CPP_PARA
+#ifdef CPP_MPI
             CALL MPI_SEND(tmp_calv(1,jj_nb),1,MPI_REAL_LMDZ,mpi_rank+1,1234,COMM_LMDZ_PHY,error)
             CALL MPI_RECV(down,1,MPI_REAL_LMDZ,mpi_rank+1,1234,COMM_LMDZ_PHY,status,error)
@@ -1095,4 +1097,5 @@
 
 ! Transform the longitudes and latitudes on 2D arrays
+    
     CALL gather_omp(rlon,rlon_mpi)
     CALL gather_omp(rlat,rlat_mpi)
@@ -1162,6 +1165,7 @@
     time_sec=(itime-1)*dtime
 #ifdef CPP_COUPLE
+    il_time_secs=(itime-1)*dtime
 !$OMP MASTER
-    CALL intocpl(time_sec, lafin, tab_flds(:,:,:))
+    CALL intocpl(il_time_secs, lafin, tab_flds(:,:,:))
 !$OMP END MASTER
 #endif
@@ -1188,5 +1192,5 @@
 !
   SUBROUTINE cpl2gath(champ_in, champ_out, knon, knindex)
-    USE mod_phys_lmdz_para
+  USE mod_phys_lmdz_para
 ! Cette routine ecrit un champ 'gathered' sur la grille 2D pour le passer
 ! au coupleur.
@@ -1218,4 +1222,6 @@
 !*************************************************************************************
 !
+    
+
 ! Transform from 2 dimensions (iim,jj_nb) to 1 dimension (klon)
 !$OMP MASTER 
@@ -1230,5 +1236,5 @@
        champ_out(i) = temp_omp(ig)
     ENDDO
-   
+
   END SUBROUTINE cpl2gath
 !
